// vektor3dklasse.h

#ifndef VEKTOR3DKLASSE_H
#define VEKTOR3DKLASSE_H
#include "vektorklasse.h"

inline double absd(double x) {return (x<0)?-x:x;}

class Vektor3d
{
public:
 double x,y,z;
 Vektor3d() {x=y=z=0;}
 Vektor3d(double a,double b=0,double c=0) {x=a; y=b; z=c;}
 double get(int i) {if(i==0) return x; if(i==1) return y; if(i==2) return z;
		    return sqrt(x*x+y*y+z*z); //Betrag
		   }
 Vektor3d operator=(double a) {x=a; y=z=0; return *this;}
 Vektor3d operator=(vektor v) {x=v.x; y=v.y; z=0; return *this;}
 //Vektor3d operator=(Vektor3d v) {x=v.x; y=v.y; z=v.z; return *this;}
 Vektor3d operator+=(Vektor3d v) {x+=v.x; y+=v.y; z+=v.z; return *this;}
 Vektor3d operator-=(Vektor3d v) {x-=v.x; y-=v.y; z-=v.z; return *this;}
 Vektor3d operator*=(double a) {x*=a; y*=a; z*=a; return *this;}
 Vektor3d operator/=(double a) {x/=a; y/=a; z/=a; return *this;}
 Vektor3d einheitsvektor()
	{double wu=sqrt(x*x+y*y+z*z); x/=wu; y/=wu; z/=wu; return *this;}
 double& operator[](int i) {return i==0?x:(i==1?y:z);}
 friend Vektor3d operator+(Vektor3d,Vektor3d);
 friend Vektor3d operator-(Vektor3d,Vektor3d);
 friend Vektor3d operator*(Vektor3d,double);
 friend Vektor3d operator*(double,Vektor3d);
 friend Vektor3d operator*(Vektor3d,Vektor3d);
 friend Vektor3d operator/(Vektor3d,double);
 friend Vektor3d operator/(Vektor3d,Vektor3d);//provi.
 friend Vektor3d operator-(Vektor3d);
 void drehenxy(double sw,double cw);
 void drehenyx(double sw,double cw);
 void drehenxy(double w) {drehenxy(sin(w),cos(w));}
 void drehenyx(double w) {drehenxy(-sin(w),cos(w));}
 void drehenzx(double sw,double cw);
 void drehenxz(double sw,double cw);
 void drehenzx(double w) {drehenzx(sin(w),cos(w));}
 void drehenxz(double w) {drehenzx(-sin(w),cos(w));}
 void drehenyz(double sw,double cw);
 void drehenzy(double sw,double cw);
 void drehenyz(double w) {drehenyz(sin(w),cos(w));}
 void drehenzy(double w) {drehenyz(-sin(w),cos(w));}
};
#endif
